CHANGES IN VERSION 3.47.1
-------------------------

    o Add warning message when the input is not unique for genomicElementDistribution.
    
CHANGES IN VERSION 3.45.3
-------------------------

    o Fix the issue for biomaRt in vignettes.
    
CHANGES IN VERSION 3.45.2
-------------------------

    o Remove microRNAs from annoGR
    
CHANGES IN VERSION 3.45.1
-------------------------

    o Remove microRNAs from assignChromosomeRegion.
    
CHANGES IN VERSION 3.43.2
-------------------------

    o Fix an issue for the corrdinates changes of GRCh37 annotation.
    
CHANGES IN VERSION 3.43.1
-------------------------

    o Fix an issue in genomicElementDistribution when convert seqlevelsStyle.
    
CHANGES IN VERSION 3.41.1
-------------------------

    o Update Jianhong's email address.
    
CHANGES IN VERSION 3.39.3
-------------------------

    o Fix the documentation for Vennerable.
    
CHANGES IN VERSION 3.39.2
-------------------------

    o Fix the documentation for summarizePatterInPeaks.
    
CHANGES IN VERSION 3.39.1
-------------------------

    o Unique promoters for genomicElementDistribution.
    
CHANGES IN VERSION 3.37.5
-------------------------

    o Update by importing pwalign.
    
CHANGES IN VERSION 3.37.4
-------------------------

    o Handle the biofilecache error.

CHANGES IN VERSION 3.37.3
-------------------------

    o use an updated and unified single vignette to replace the four old ones
    o remove oligoNucleotideEnrichment.R and incorporate it into summarizePatternsInPeaks.R
    o update findMotifsInPromoterSeqs.R to match changes in summarizePatternsInPeaks.R
    
CHANGES IN VERSION 3.37.2
-------------------------

    o export function oligoNucleotideEnrichment
    
CHANGES IN VERSION 3.37.1
-------------------------

    o export disable.logging parameter for venn.diagram called by
    makeVennDiagram

CHANGES IN VERSION 3.35.3
-------------------------

    o update documentation for the annotatePeakInBatch function

CHANGES IN VERSION 3.35.1
-------------------------

    o fix the seqlevelsStyle check for custom species.

CHANGES IN VERSION 3.33.2
-------------------------

    o update the documentation for enrichment analysis
    
CHANGES IN VERSION 3.33.1
-------------------------

    o update the disjointExons to exonicParts for ensembldb


CHANGES IN VERSION 3.31.4
-------------------------

    o update the oligoFrequency function to remove the limitation of sequence
    length
    
CHANGES IN VERSION 3.31.3
-------------------------

    o support `CSV` format for `toGRanges`
    
CHANGES IN VERSION 3.31.2
-------------------------

    o use 'entrez_id' instead of 'EntrezID' for getEnrichedPATH() output
    
CHANGES IN VERSION 3.31.1
-------------------------

    o add parameter check of proximal.promoter.cutoff and
    immediate.downstream.cutoff for assignChromosomeRegion.
    o fix the bug in `plotBinOverRegions`
    
CHANGES IN VERSION 3.29.6
-------------------------

    o update jianhong's email
    
CHANGES IN VERSION 3.29.5
-------------------------

    o update the pipeline documentation to avoid the error when converting the
    GRanges object to data.frame.

CHANGES IN VERSION 3.29.3
-------------------------

    o handle the error "non standard bed file."
    
CHANGES IN VERSION 3.29.2
-------------------------

    o fix the error: trying to generate an object from a virtual class "DataFrame".
    
CHANGES IN VERSION 3.29.1
-------------------------

    o add subGroupComparison parameter to getEnrichedGO and getEnrichedPATH.
    
CHANGES IN VERSION 3.27.7
-------------------------

    o Fix the error "!anyNA(m32) is not TRUE" in seqlevelsStyle is not
    handled.
    
CHANGES IN VERSION 3.27.6
-------------------------

    o Fix the error "pvalue" undefined columns selected in enrichmentPlot
    
CHANGES IN VERSION 3.27.5
-------------------------

    o update documentation of pipeline.rmd

CHANGES IN VERSION 3.27.4
-------------------------

    o use formatSeqnames function to handle the error from seqlevelsStyle:
    "cannot switch some of GRCm38's seqlevels from NCBI to UCSC style"
    
CHANGES IN VERSION 3.27.3
-------------------------

    o use formatSeqnames function to handle the error from seqlevelsStyle:
    "!anyNA(m31) is not TRUE "
    
CHANGES IN VERSION 3.27.2
-------------------------

    o add keepExonsInGenesOnly for genomicElementDistribution
    o add upstream and downstream for assignChromosomeRegion function when define promoter and downstream regions.
    
CHANGES IN VERSION 3.27.1
-------------------------

    o Add the possibility of find overlaps by percentage covered of interval
    for function findOverlapsOfPeaks

CHANGES IN VERSION 3.25.6
-------------------------

    o Fix a bug in estLibSize introduced by last push.
    
CHANGES IN VERSION 3.25.5
-------------------------

    o Add LazyDataCompression in description

CHANGES IN VERSION 3.25.4
-------------------------

    o Add choice endMinusStart to annotatePeakInBatch.
    
CHANGES IN VERSION 3.25.3
-------------------------

    o fix the missing link of documentation for rtracklyaer:import.
    
CHANGES IN VERSION 3.25.2
-------------------------

    o update documentation.
    o update findEnhancers to for known interaction data
    
CHANGES IN VERSION 3.25.1
-------------------------

    o fix the bug for genomicElementDistribution when the peak length is zero.
    
CHANGES IN VERSION 3.23.12
-------------------------

    o fix the bug for genomicElementDistribution when the order of SortedByQueryHits is incorrect.
    
CHANGES IN VERSION 3.23.11
-------------------------

    o use seqlevelsStyle to reformat the seqlevels for annotation.
    
CHANGES IN VERSION 3.23.10
-------------------------

    o update documentation for genomicElementDistribution
    
CHANGES IN VERSION 3.23.9
-------------------------

    o add new function enrichmentPlot, genomicElementDistribution, genomicElementUpSetR, and methagenePlot to improve visualization.
    
CHANGES IN VERSION 3.23.8
-------------------------

    o update documentation for findOverlapsOfPeaks.
    
CHANGES IN VERSION 3.23.7
-------------------------

    o update documentation for findOverlapsOfPeaks.
    
CHANGES IN VERSION 3.23.6
-------------------------

    o change parameter from otherCount to otherCounts to makeVennDiagram function.
    
CHANGES IN VERSION 3.23.5
-------------------------

    o add plot parameter to makeVennDiagram function.
    
CHANGES IN VERSION 3.23.4
-------------------------

    o update README file.
    
CHANGES IN VERSION 3.23.3
-------------------------

    o use roxygen2 to generate the help file.
    o move multiple package from Imports to Suggests.

CHANGES IN VERSION 3.23.2
-------------------------

    o fix the issue for new paste output.
    
CHANGES IN VERSION 3.23.1
-------------------------

    o remove dependence of Rfast

CHANGES IN VERSION 3.21.7
-------------------------

    o Fix a potentical bug reported by millerh1. 
    
CHANGES IN VERSION 3.21.6
-------------------------

    o add new function findMotifsInPromoterSeqs.
    
HANGES IN VERSION 3.21.5
-------------------------

    o replace all `class` by `is`.
    
CHANGES IN VERSION 3.21.4
-------------------------

    o Fix a bug in getAllPeakSequence when there is peak out side of genome.
    
CHANGES IN VERSION 3.21.3
-------------------------

    o Update function summarizePatternInPeaks.
    
CHANGES IN VERSION 3.21.2
-------------------------

    o Add function getGO.
    

CHANGES IN VERSION 3.21.1
-------------------------

    o remove RangedData from ChIPpeakAnno.

CHANGES IN VERSION 3.19.5
-------------------------

    o fix the issue that findOverlapsOfPeaks will connect the peaks in same peak list.
    
CHANGES IN VERSION 3.19.4
-------------------------

    o add last choice for xget.
    
CHANGES IN VERSION 3.19.3
-------------------------

    o fix the colnames of addMetadata.

CHANGES IN VERSION 3.19.2
-------------------------

    o fix the issue that seqlevelsStyle(peak) == seqlevelsStyle(annotation) are not all TRUE

CHANGES IN VERSION 3.19.1
-------------------------

    o remove RangedData

CHANGES IN VERSION 3.17.2
-------------------------

    o fix a bug in toGRanges to accept GTF files.
    
CHANGES IN VERSION 3.17.1
-------------------------

    o fix the bug in annotatePeakInBatch which can not accept bindingType parameter.
    
CHANGES IN VERSION 3.15.2
-------------------------

    o fix the bug in binOverRegions and binOverGene

CHANGES IN VERSION 3.15.1
-------------------------

    o Fix the bug in assignChromosomeRegion for the Jaccard index calculation.

CHANGES IN VERSION 3.13.19
-------------------------

    o Fix the bug in assignChromosomeRegion for the percentage calculation when nucleotideLevel equal to true.
    
CHANGES IN VERSION 3.13.18
-------------------------

    o Fix the bug in assignChromosomeRegion for resetting seqlevels.
    
CHANGES IN VERSION 3.13.17
-------------------------

    o Fix the bug in annoScore by setting the ignore.strand for punion.
    
CHANGES IN VERSION 3.13.16
-------------------------

    o Fix the bug in assignChromosomeRegion for the integer overflow.
    
CHANGES IN VERSION 3.13.14
-------------------------

    o Fix the warnings under windows.
    
CHANGES IN VERSION 3.13.12
-------------------------

    o Change "class" function to "is" function.
    
CHANGES IN VERSION 3.13.11
-------------------------

    o Fix the help file for assignChromosomeRegion.
    
CHANGES IN VERSION 3.13.10
-------------------------

    o Improve binOverRegions.
    
CHANGES IN VERSION 3.13.9
-------------------------

    o Improve addMetadata.
    
CHANGES IN VERSION 3.13.8
-------------------------

    o Fix the warnings under windows.
    
CHANGES IN VERSION 3.13.6
-------------------------

    o Improve the functions featureAlignedSignal and featureAlignedExtendSignal
    
CHANGES IN VERSION 3.13.5
-------------------------

    o add minFragmentSize parameter to estFragmentLength

CHANGES IN VERSION 3.13.4
-------------------------

    o suppress the message from featureAlignedExtendSignal
    o modified help files to make the samples run on local test.
    
CHANGES IN VERSION 3.13.3
-------------------------

    o fix the bug in binOverRegions and binOverGene
    
CHANGES IN VERSION 3.13.2
-------------------------

    o featureAlignedSignal generate outputs with rownames

CHANGES IN VERSION 3.13.1
-------------------------

    o change the test value from GNAI3;MIR197 to GNAI3 to avoid the error because of 
    update of annotation database.
    
CHANGES IN VERSION 3.11.8
-------------------------

    o make featureAlignedExtendSignal accept GAlignments list object
    
CHANGES IN VERSION 3.11.6
-------------------------

    o fix the bugs Codoc mismatches from documentation object 'peakPermTest'

CHANGES IN VERSION 3.11.4
-------------------------

    o fix the bugs when annoMcols is numeric values.
    
CHANGES IN VERSION 3.11.3
-------------------------

    o update the function featureAlignedSignal
    
CHANGES IN VERSION 3.11.2
-------------------------

    o add new function binOverGene, binOverRegions, plotBinOverRegions.
    
CHANGES IN VERSION 3.11.1
-------------------------

    o make FAQs availble
    o Fix the bug in annoPeaks for warning of out-of-bound ranges

CHANGES IN VERSION 3.9.19
-------------------------

    o add FAQs


CHANGES IN VERSION 3.9.18
-------------------------

    o import rowRanges() generic from DelayedArray instead of SummarizedExperiment
    
CHANGES IN VERSION 3.9.17
-------------------------

    o Improve the function featureAlignedExtendSignal
    
CHANGES IN VERSION 3.9.16
-------------------------
    o Fix the bug that unable to find an inherited method for function 
    'reverseComplement' for signature '"BString"' in oligoSummary function.
    
CHANGES IN VERSION 3.9.14
-------------------------
    o re-order the signals for cumulativePercentage.
    
CHANGES IN VERSION 3.9.13
-------------------------
    o add new function cumulativePercentage.
    
CHANGES IN VERSION 3.9.12
-------------------------
    o remove unused code in oligoSummary.

CHANGES IN VERSION 3.9.11
-------------------------
    o update the documents of featureAlignedSignal.

CHANGES IN VERSION 3.9.10
-------------------------
    o fix the bug of featureAlignedSignal when there are seqnames in featues but
    not in cvglists.

CHANGES IN VERSION 3.9.9
-------------------------
    o add 2 more parameters to getEnrichedGO
    
CHANGES IN VERSION 3.9.8
-------------------------
    o update the colnames of toGRanges
    
CHANGES IN VERSION 3.9.7
-------------------------
    o fix the bug of findOverlapsOfPeaks when the peaks are exactly same

CHANGES IN VERSION 3.9.6
-------------------------
    o fix the bug of findOverlapsOfPeaks when there is no peak names for peaklist
    
CHANGES IN VERSION 3.9.5
-------------------------
    o update the documents of findOverlapsOfPeaks
    
CHANGES IN VERSION 3.9.4
-------------------------
    o update the documents of getEnrichedGO
    o add more output for findOverlapsOfPeaks.
    
CHANGES IN VERSION 3.9.3
-------------------------
    o trim seqnames when using toGRanges

CHANGES IN VERSION 3.9.2
-------------------------
    o add adjustFragmentLength for featureAlignedExtendSignal.
    
CHANGES IN VERSION 3.9.1
-------------------------
    o fix the bug for pair end reads for featureAlignedExtendSignal.

CHANGES IN VERSION 3.7.9
-------------------------
    o fix the problem in the test when there are names for target but not 
    for current.
    
CHANGES IN VERSION 3.7.8
-------------------------
    o remove the dependence of MMDiffBamSubset in documentation becuase it is
    not availble now.
    
CHANGES IN VERSION 3.7.7
-------------------------
    o fix bugs for toGRanges to import MACS2 broad calls.
    
CHANGES IN VERSION 3.7.6
-------------------------
    o add new functions tileGRanges, tileCount
    
CHANGES IN VERSION 3.7.5
-------------------------
    o add parameter select to annoPeaks 

CHANGES IN VERSION 3.7.3
-------------------------
    o add new function featureAlignedExtendSignal, estLibSize, estFragmentLength

CHANGES IN VERSION 3.7.2
-------------------------
    o Correct typo in documentation for Z-score.
    o Improve the efficiency of findOverlapsOfPeaks.

CHANGES IN VERSION 3.5.18
-------------------------
    o Fix the bugs for featureAlignedSignal when features 
    contain strand info.

CHANGES IN VERSION 3.5.17
-------------------------
    o Fix the bugs for getEnrichedGO/PATH when recodes in 
    database such as reactome database is not unique.
    
    
CHANGES IN VERSION 3.5.16
-------------------------
    o fix the warning in windows for replacing previous import 

CHANGES IN VERSION 3.5.15
-------------------------
    o not do log2 transform for featureAlignedSingal
    
CHANGES IN VERSION 3.5.14
-------------------------
    o remove NA for featureAlignedDistribution
    o handle NA and infinite value for featureAlignedSingal
    
CHANGES IN VERSION 3.5.13
-------------------------
    o throw message when seqlevels are not identical 
    for featureAlignedSignal
    
CHANGES IN VERSION 3.5.12
-------------------------
    o add new function summarizeOverlapsByBins.
    
CHANGES IN VERSION 3.5.11
-------------------------
    o clean output of findEnhancers
    
CHANGES IN VERSION 3.5.10
-------------------------
    o add new function findEnhancers
    o normalize the output of gene region for binOverFeature
    o change the documentation to avoid time-out error
    
CHANGES IN VERSION 3.5.9
-------------------------
    o merge peaksNearBDP and bdp function.
    o improve oligoSummary.
    o update the documentations.
    
CHANGES IN VERSION 3.5.8
-------------------------
    o change toGRanges from function to method
    o update the documentations.

CHANGES IN VERSION 3.5.7
-------------------------
    o change test from RUnit to testthat
    o add new function addMetadata
    o change the output and parameters of annoPeaks
    o simple the parameter output of annotatePeakInBatch
    o allow bdp function to accept GRanges annotation
    o add error bar function for binOverFeature function
    o remove the log file after plot for makeVennDiagram function
    o add private function trimPeakList
    o update the documentation of annoPeaks and annotatePeakInBatch
    
CHANGES IN VERSION 3.5.5
-------------------------
    o update the documentation to fix the typo in quickStart.
    o change the default value of annoPeaks.
    o update annoGR class to fix the error: 
      identical(colnames(classinfo), colnames(out)) is not TRUE

CHANGES IN VERSION 3.5.2
-------------------------
    o update the documentation to fix the error on windows (import bigwig error)
    o avoid the output of addGeneIDs as factors

CHANGES IN VERSION 3.5.1
-------------------------
    o update the documentation
NEW FEATURE
    o toGRanges can accept connection object
    o add annoPeaks function
    o add xget function
    o update the peakPermTest algorithm to make more reasonable result.
    o add oligoSummary function
    o add IDRfilter function
    o add reCenterPeaks function

CHANGES IN VERSION 3.3.8
-------------------------
    o update the documentation


CHANGES IN VERSION 3.3.7
-------------------------
FIX BUGS
    o fix the problem in creating vignettes in linux platform.

CHANGES IN VERSION 3.3.6
-------------------------
NEW FEATURE
    o add new function featureAlignedSignal, featureAlignedDistribution,
      featureAlignedHeatmap, pie1
    o add new dataset HOT.spots, wgEncodeTfbsV3
    o update annoGR class
    o update vignettes

CHANGES IN VERSION 3.3.5
-------------------------
NEW FEATURE
    o remove all the RangedData
    o add annoGR class
    o update vignettes

CHANGES IN VERSION 3.3.4
-------------------------
NEW FEATURE
    o toGRanges from MACS2, narrowPeak.
    o calculate the p value of overlapping peaks by reagioneR
    o update documentation

CHANGES IN VERSION 3.3.3
-------------------------
NEW FEATURE
    o mergePlusMinusPeaks

CHANGES IN VERSION 3.3.2
-------------------------
NEW FEATURE
    o update citation

CHANGES IN VERSION 3.3.1
-------------------------
NEW FEATURE
    o add new citation

CHANGES IN VERSION 3.0.1
-------------------------
BUG FIXES
    o give errors when inputs of addGeneIDs is incorrect.

CHANGES IN VERSION 3.0.0
-------------------------
NEW FEATURE

     o From RangedData to Granges
     o High efficiency
     o Find Overlaps for more than 2 groups 
     o Add Utility test 
     o Add new function binOverFeature, egOrgMap.

CHANGES IN VERSION 2.17.2
------------------------
NEW FEATURE

    o add byBase for makeVennDiagram.

CHANGES IN VERSION 2.11.4
------------------------
NEW FEATURE

    o Add selection of 'shortestDistance' to output parameter of annotatePeakInBatch.


CHANGES IN VERSION 2.12.3
------------------------
BUG FIXES

    o relative postion for negative strand are not correct when call findOverlappingPeaks.

CHANGES IN VERSION 2.11.4
------------------------
NEW FEATURE

    o Add selection of 'shortestDistance' to output parameter of annotatePeakInBatch.

CHANGES IN VERSION 2.11.3
------------------------
NEW FEATURE

    o Improved efficiency of annotatePeakInBatch.

CHANGES IN VERSION 2.9.6
------------------------
BUG FIXES

    o Changed Enhancer.Silencer to intergenic.Region in assignChromosomeRegion.

CHANGES IN VERSION 2.9.5
------------------------
BUG FIXES

    o negative widths are not allowed when call findOverlappingPeaks.


NEW FEATURES IN VERSION 2.2.0
------------------------

     o Find the peaks with bi-directional promoters with summary
     statistics (peaksNearBDP).

     o Summarize the occurrence of motifs in peaks
     (summarizePatternInPeaks).

     o Add other IDs to annotated peaks or enrichedGO (addGeneIDs)The
     function makeVennDiagram supports 4-way venn diagram.

     o Enriched Gene Ontology (GO) terms are annotated with a list of
     genes which can be traced back to peaks.

     o FAQ: http://pgfe.umassmed.edu/ChIPpeakAnno/FAQ.html.

     o Summarize peak distribution over exon, intron, enhancer, proximal promoter, 5 prime UTR and 3 prime UTR (assignChromosomeRegion)
